"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from synctera_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from synctera_client.exceptions import ApiAttributeError


def lazy_import():
    from synctera_client.model.account_verification import AccountVerification
    from synctera_client.model.add_accounts_request_account_identifiers import AddAccountsRequestAccountIdentifiers
    from synctera_client.model.add_accounts_request_routing_identifiers import AddAccountsRequestRoutingIdentifiers
    from synctera_client.model.ext_account_customer_type import ExtAccountCustomerType
    globals()['AccountVerification'] = AccountVerification
    globals()['AddAccountsRequestAccountIdentifiers'] = AddAccountsRequestAccountIdentifiers
    globals()['AddAccountsRequestRoutingIdentifiers'] = AddAccountsRequestRoutingIdentifiers
    globals()['ExtAccountCustomerType'] = ExtAccountCustomerType


class AddAccountsRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'CHECKING': "CHECKING",
            'SAVINGS': "SAVINGS",
        },
    }

    validations = {
        ('account_owner_names',): {
            'min_items': 1,
        },
        ('nickname',): {
            'min_length': 1,
        },
        ('vendor_account_id',): {
            'min_length': 1,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'account_identifiers': (AddAccountsRequestAccountIdentifiers,),  # noqa: E501
            'account_owner_names': ([str],),  # noqa: E501
            'customer_type': (ExtAccountCustomerType,),  # noqa: E501
            'routing_identifiers': (AddAccountsRequestRoutingIdentifiers,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'business_id': (str,),  # noqa: E501
            'customer_id': (str,),  # noqa: E501
            'metadata': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'nickname': (str,),  # noqa: E501
            'vendor_account_id': (str,),  # noqa: E501
            'verification': (AccountVerification,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'account_identifiers': 'account_identifiers',  # noqa: E501
        'account_owner_names': 'account_owner_names',  # noqa: E501
        'customer_type': 'customer_type',  # noqa: E501
        'routing_identifiers': 'routing_identifiers',  # noqa: E501
        'type': 'type',  # noqa: E501
        'business_id': 'business_id',  # noqa: E501
        'customer_id': 'customer_id',  # noqa: E501
        'metadata': 'metadata',  # noqa: E501
        'nickname': 'nickname',  # noqa: E501
        'vendor_account_id': 'vendor_account_id',  # noqa: E501
        'verification': 'verification',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, account_identifiers, account_owner_names, customer_type, routing_identifiers, type, *args, **kwargs):  # noqa: E501
        """AddAccountsRequest - a model defined in OpenAPI

        Args:
            account_identifiers (AddAccountsRequestAccountIdentifiers):
            account_owner_names ([str]): The names of the account owners.
            customer_type (ExtAccountCustomerType):
            routing_identifiers (AddAccountsRequestRoutingIdentifiers):
            type (str): The type of the account

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            business_id (str): The identifier for the business customer associated with this external account. Exactly one of `business_id` or `customer_id` must be specified. . [optional]  # noqa: E501
            customer_id (str): The identifier for the personal customer associated with this external account. Exactly one of `customer_id` or `business_id` must be specified. . [optional]  # noqa: E501
            metadata ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): User-supplied metadata. [optional]  # noqa: E501
            nickname (str): A user-meaningful name for the account. [optional]  # noqa: E501
            vendor_account_id (str): The ID of the vendor account, will be empty for MANUAL vendor. [optional]  # noqa: E501
            verification (AccountVerification): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.account_identifiers = account_identifiers
        self.account_owner_names = account_owner_names
        self.customer_type = customer_type
        self.routing_identifiers = routing_identifiers
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, account_identifiers, account_owner_names, customer_type, routing_identifiers, type, *args, **kwargs):  # noqa: E501
        """AddAccountsRequest - a model defined in OpenAPI

        Args:
            account_identifiers (AddAccountsRequestAccountIdentifiers):
            account_owner_names ([str]): The names of the account owners.
            customer_type (ExtAccountCustomerType):
            routing_identifiers (AddAccountsRequestRoutingIdentifiers):
            type (str): The type of the account

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            business_id (str): The identifier for the business customer associated with this external account. Exactly one of `business_id` or `customer_id` must be specified. . [optional]  # noqa: E501
            customer_id (str): The identifier for the personal customer associated with this external account. Exactly one of `customer_id` or `business_id` must be specified. . [optional]  # noqa: E501
            metadata ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): User-supplied metadata. [optional]  # noqa: E501
            nickname (str): A user-meaningful name for the account. [optional]  # noqa: E501
            vendor_account_id (str): The ID of the vendor account, will be empty for MANUAL vendor. [optional]  # noqa: E501
            verification (AccountVerification): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.account_identifiers = account_identifiers
        self.account_owner_names = account_owner_names
        self.customer_type = customer_type
        self.routing_identifiers = routing_identifiers
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
