"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from synctera_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from synctera_client.exceptions import ApiAttributeError


def lazy_import():
    from synctera_client.model.bin import Bin
    from synctera_client.model.bin_status import BinStatus
    from synctera_client.model.brand_product_code import BrandProductCode
    from synctera_client.model.card_brand import CardBrand
    from synctera_client.model.card_category import CardCategory
    from synctera_client.model.card_product_type import CardProductType
    from synctera_client.model.country_code import CountryCode
    from synctera_client.model.currency_code import CurrencyCode
    from synctera_client.model.physical_card_format import PhysicalCardFormat
    globals()['Bin'] = Bin
    globals()['BinStatus'] = BinStatus
    globals()['BrandProductCode'] = BrandProductCode
    globals()['CardBrand'] = CardBrand
    globals()['CardCategory'] = CardCategory
    globals()['CardProductType'] = CardProductType
    globals()['CountryCode'] = CountryCode
    globals()['CurrencyCode'] = CurrencyCode
    globals()['PhysicalCardFormat'] = PhysicalCardFormat


class BinResponse(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'account_range_length': (int,),  # noqa: E501
            'bank_id': (int,),  # noqa: E501
            'billing_ica': (str,),  # noqa: E501
            'bin': (str,),  # noqa: E501
            'bin_status': (BinStatus,),  # noqa: E501
            'brand_product_code': (BrandProductCode,),  # noqa: E501
            'card_brand': (CardBrand,),  # noqa: E501
            'card_category': (CardCategory,),  # noqa: E501
            'card_product_type': (CardProductType,),  # noqa: E501
            'country': (CountryCode,),  # noqa: E501
            'creation_time': (datetime,),  # noqa: E501
            'currency': (CurrencyCode,),  # noqa: E501
            'ica_bid': (str,),  # noqa: E501
            'id': (str,),  # noqa: E501
            'is_tokenization_enabled': (bool,),  # noqa: E501
            'last_modified_time': (datetime,),  # noqa: E501
            'pan_utilization': (int,),  # noqa: E501
            'partner_id': (int,),  # noqa: E501
            'processor': (str,),  # noqa: E501
            'digital_wallet_active': (bool,),  # noqa: E501
            'end_date': (datetime,),  # noqa: E501
            'physical_card_format': (PhysicalCardFormat,),  # noqa: E501
            'start_date': (datetime,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'account_range_length': 'account_range_length',  # noqa: E501
        'bank_id': 'bank_id',  # noqa: E501
        'billing_ica': 'billing_ica',  # noqa: E501
        'bin': 'bin',  # noqa: E501
        'bin_status': 'bin_status',  # noqa: E501
        'brand_product_code': 'brand_product_code',  # noqa: E501
        'card_brand': 'card_brand',  # noqa: E501
        'card_category': 'card_category',  # noqa: E501
        'card_product_type': 'card_product_type',  # noqa: E501
        'country': 'country',  # noqa: E501
        'creation_time': 'creation_time',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'ica_bid': 'ica_bid',  # noqa: E501
        'id': 'id',  # noqa: E501
        'is_tokenization_enabled': 'is_tokenization_enabled',  # noqa: E501
        'last_modified_time': 'last_modified_time',  # noqa: E501
        'pan_utilization': 'pan_utilization',  # noqa: E501
        'partner_id': 'partner_id',  # noqa: E501
        'processor': 'processor',  # noqa: E501
        'digital_wallet_active': 'digital_wallet_active',  # noqa: E501
        'end_date': 'end_date',  # noqa: E501
        'physical_card_format': 'physical_card_format',  # noqa: E501
        'start_date': 'start_date',  # noqa: E501
    }

    read_only_vars = {
        'creation_time',  # noqa: E501
        'id',  # noqa: E501
        'last_modified_time',  # noqa: E501
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """BinResponse - a model defined in OpenAPI

        Keyword Args:
            account_range_length (int): Account range length
            bank_id (int): The bank ID
            billing_ica (str): The ICA to which fees will be billed
            bin (str): The bin number
            bin_status (BinStatus):
            brand_product_code (BrandProductCode):
            card_brand (CardBrand):
            card_category (CardCategory):
            card_product_type (CardProductType):
            country (CountryCode):
            creation_time (datetime): The timestamp representing when the bin was created
            currency (CurrencyCode):
            ica_bid (str): ICA/BID
            id (str): Bin ID
            is_tokenization_enabled (bool): Controls whether bin allows tokenization. defaults to False  # noqa: E501
            last_modified_time (datetime): The timestamp representing when the bin was last modified
            pan_utilization (int): Pan utilization
            partner_id (int): The partner ID
            processor (str): The name of the card processor
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            digital_wallet_active (bool): Determines if bin supports digital wallet tokenization. [optional] if omitted the server will use the default value of False  # noqa: E501
            end_date (datetime): The time when bin is decommissioned. [optional]  # noqa: E501
            physical_card_format (PhysicalCardFormat): [optional]  # noqa: E501
            start_date (datetime): The time when bin goes live. [optional]  # noqa: E501
        """

        is_tokenization_enabled = kwargs.get('is_tokenization_enabled', False)
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """BinResponse - a model defined in OpenAPI

        Keyword Args:
            account_range_length (int): Account range length
            bank_id (int): The bank ID
            billing_ica (str): The ICA to which fees will be billed
            bin (str): The bin number
            bin_status (BinStatus):
            brand_product_code (BrandProductCode):
            card_brand (CardBrand):
            card_category (CardCategory):
            card_product_type (CardProductType):
            country (CountryCode):
            currency (CurrencyCode):
            ica_bid (str): ICA/BID
            is_tokenization_enabled (bool): Controls whether bin allows tokenization. defaults to False  # noqa: E501
            pan_utilization (int): Pan utilization
            partner_id (int): The partner ID
            processor (str): The name of the card processor
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            digital_wallet_active (bool): Determines if bin supports digital wallet tokenization. [optional] if omitted the server will use the default value of False  # noqa: E501
            end_date (datetime): The time when bin is decommissioned. [optional]  # noqa: E501
            physical_card_format (PhysicalCardFormat): [optional]  # noqa: E501
            start_date (datetime): The time when bin goes live. [optional]  # noqa: E501
        """

        is_tokenization_enabled = kwargs.get('is_tokenization_enabled', False)
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              Bin,
          ],
          'oneOf': [
          ],
        }
