"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from synctera_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from synctera_client.exceptions import ApiAttributeError



class OriginalCreditSenderData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('funding_source',): {
            'CREDIT': "credit",
            'DEBIT': "debit",
            'PREPAID': "prepaid",
            'DEPOSIT_ACCOUNT': "deposit_account",
            'CASH': "cash",
            'MOBILE_MONEY_PAYMENT': "mobile_money_payment",
            'NON_VISA_CREDIT': "non_visa_credit",
        },
        ('sender_account_type',): {
            'OTHER': "other",
            'RTN_BANK_ACCOUNT': "rtn_bank_account",
            'IBAN': "iban",
            'CARD_ACCOUNT': "card_account",
            'EMAIL': "email",
            'PHONE_NUMBER': "phone_number",
            'BANK_ACCOUNT_NUMBER_AND_IDENTIFICATION_CODE': "bank_account_number_and_identification_code",
            'WALLET_ID': "wallet_id",
            'SOCIAL_NETWORK_ID': "social_network_id",
        },
        ('transaction_purpose',): {
            'FAMILY_SUPPORT': "family_support",
            'LABOR_TRANSFERS': "labor_transfers",
            'TRAVEL': "travel",
            'EDUCATION': "education",
            'MEDICAL_TREATMENT': "medical_treatment",
            'EMERGENCY_NEED': "emergency_need",
            'SAVINGS': "savings",
            'GIFTS': "gifts",
            'OTHER': "other",
            'SALARY': "salary",
            'LENDING': "lending",
            'CRYPTO_CURRENCY': "crypto_currency",
        },
    }

    validations = {
        ('unique_transaction_reference_number',): {
            'max_length': 17,
            'min_length': 1,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'funding_source': (str,),  # noqa: E501
            'sender_account_number': (str,),  # noqa: E501
            'sender_account_type': (str,),  # noqa: E501
            'sender_address': (str,),  # noqa: E501
            'sender_city': (str,),  # noqa: E501
            'sender_country': (str,),  # noqa: E501
            'sender_name': (str,),  # noqa: E501
            'sender_reference_number': (str,),  # noqa: E501
            'sender_state': (str,),  # noqa: E501
            'transaction_purpose': (str,),  # noqa: E501
            'unique_transaction_reference_number': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'funding_source': 'funding_source',  # noqa: E501
        'sender_account_number': 'sender_account_number',  # noqa: E501
        'sender_account_type': 'sender_account_type',  # noqa: E501
        'sender_address': 'sender_address',  # noqa: E501
        'sender_city': 'sender_city',  # noqa: E501
        'sender_country': 'sender_country',  # noqa: E501
        'sender_name': 'sender_name',  # noqa: E501
        'sender_reference_number': 'sender_reference_number',  # noqa: E501
        'sender_state': 'sender_state',  # noqa: E501
        'transaction_purpose': 'transaction_purpose',  # noqa: E501
        'unique_transaction_reference_number': 'unique_transaction_reference_number',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, funding_source, *args, **kwargs):  # noqa: E501
        """OriginalCreditSenderData - a model defined in OpenAPI

        Args:
            funding_source (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            sender_account_number (str): [optional]  # noqa: E501
            sender_account_type (str): [optional]  # noqa: E501
            sender_address (str): [optional]  # noqa: E501
            sender_city (str): [optional]  # noqa: E501
            sender_country (str): [optional]  # noqa: E501
            sender_name (str): [optional]  # noqa: E501
            sender_reference_number (str): [optional]  # noqa: E501
            sender_state (str): [optional]  # noqa: E501
            transaction_purpose (str): [optional]  # noqa: E501
            unique_transaction_reference_number (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.funding_source = funding_source
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, funding_source, *args, **kwargs):  # noqa: E501
        """OriginalCreditSenderData - a model defined in OpenAPI

        Args:
            funding_source (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            sender_account_number (str): [optional]  # noqa: E501
            sender_account_type (str): [optional]  # noqa: E501
            sender_address (str): [optional]  # noqa: E501
            sender_city (str): [optional]  # noqa: E501
            sender_country (str): [optional]  # noqa: E501
            sender_name (str): [optional]  # noqa: E501
            sender_reference_number (str): [optional]  # noqa: E501
            sender_state (str): [optional]  # noqa: E501
            transaction_purpose (str): [optional]  # noqa: E501
            unique_transaction_reference_number (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.funding_source = funding_source
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
